GeographicLib: GeographicLib::LambertConformalConic Class Reference

GeographicLib 2.5.2

Loading...
Searching...
No Matches
GeographicLib::LambertConformalConic Class Reference

Lambert conformal conic projection. More...

`#include <GeographicLib/LambertConformalConic.hpp>`

## Public Member Functions
| LambertConformalConic (real a, real f, real stdlat, real k0)
| LambertConformalConic (real a, real f, real stdlat1, real stdlat2, real k1)
| LambertConformalConic (real a, real f, real sinlat1, real coslat1, real sinlat2, real coslat2, real k1)
void | SetScale (real lat, real k=real(1))
void | Forward (real lon0, real lat, real lon, real &x, real &y, real &gamma, real &k) const
void | Reverse (real lon0, real x, real y, real &lat, real &lon, real &gamma, real &k) const
void | Forward (real lon0, real lat, real lon, real &x, real &y) const
void | Reverse (real lon0, real x, real y, real &lat, real &lon) const
Inspector functions
Math::real | EquatorialRadius () const
Math::real | Flattening () const
Math::real | OriginLatitude () const
Math::real | CentralScale () const

## Static Public Member Functions
static const LambertConformalConic & | Mercator ()

## Detailed Description

Lambert conformal conic projection.

Implementation taken from the report,

- J. P. Snyder, Map Projections: A Working Manual, USGS Professional Paper 1395 (1987), pp. 107–109.

This is a implementation of the equations in Snyder except that divided differences have been used to transform the expressions into ones which may be evaluated accurately and that Newton's method is used to invert the projection. In this implementation, the projection correctly becomes the Mercator projection or the polar stereographic projection when the standard latitude is the equator or a pole. The accuracy of the projections is about 10 nm (10 nanometers).

The ellipsoid parameters, the standard parallels, and the scale on the standard parallels are set in the constructor. Internally, the case with two standard parallels is converted into a single standard parallel, the latitude of tangency (also the latitude of minimum scale), with a scale specified on this parallel. This latitude is also used as the latitude of origin which is returned by LambertConformalConic::OriginLatitude. The scale on the latitude of origin is given by LambertConformalConic::CentralScale. The case with two distinct standard parallels where one is a pole is singular and is disallowed. The central meridian (which is a trivial shift of the longitude) is specified as the lon0 argument of the LambertConformalConic::Forward and LambertConformalConic::Reverse functions.

This class also returns the meridian convergence gamma and scale k. The meridian convergence is the bearing of grid north (the y axis) measured clockwise from true north.

There is no provision in this class for specifying a false easting or false northing or a different latitude of origin. However these are can be simply included by the calling function. For example the Pennsylvania South state coordinate system (EPSG:3364) is obtained by:

// Example of using the GeographicLib::LambertConformalConic class
#include <iostream>
#include <exception>
#include <GeographicLib/LambertConformalConic.hpp>
using namespace std;
using namespace GeographicLib;
int main() {
try {
// Define the Pennsylvania South state coordinate system EPSG:3364
// https://www.spatialreference.org/ref/epsg/3364/
const double
a = Constants::WGS84_a(),
f = 1/298.257222101, // GRS80
lat1 = 40 + 58/60.0, lat2 = 39 + 56/60.0, // standard parallels
k1 = 1, // scale
lat0 = 39 + 20/60.0, lon0 =-77 - 45/60.0, // origin
fe = 600000, fn = 0; // false easting and northing
// Set up basic projection
const LambertConformalConic PASouth(a, f, lat1, lat2, k1);
double x0, y0;
// Transform origin point
PASouth.Forward(lon0, lat0, lon0, x0, y0);
x0 -= fe; y0 -= fn;
{
// Sample conversion from geodetic to PASouth grid
double lat = 39.95, lon = -75.17; // Philadelphia
double x, y;
PASouth.Forward(lon0, lat, lon, x, y);
x -= x0; y -= y0;
cout << x << " " << y << "\n";
}
{
// Sample conversion from PASouth grid to geodetic
double x = 820e3, y = 72e3;
double lat, lon;
x += x0; y += y0;
PASouth.Reverse(lon0, x, y, lat, lon);
cout << lat << " " << lon << "\n";
}
}
catch (const exception& e) {
cerr << "Caught exception: " << e.what() << "\n";
return 1;
}
}
main
int main(int argc, const char *const argv[])
Definition CartConvert.cpp:28
LambertConformalConic.hpp
Header for GeographicLib::LambertConformalConic class.
GeographicLib::Constants::WGS84_a
static T WGS84_a()
Definition Constants.hpp:135
GeographicLib::LambertConformalConic::LambertConformalConic
LambertConformalConic(real a, real f, real stdlat, real k0)
Definition LambertConformalConic.cpp:16
GeographicLib
Namespace for GeographicLib.
Definition Accumulator.cpp:12
std
Definition NearestNeighbor.hpp:806

ConicProj is a command-line utility providing access to the functionality of LambertConformalConic and AlbersEqualArea.

Definition at line 63 of file LambertConformalConic.hpp.

## Constructor & Destructor Documentation

## ◆ LambertConformalConic() [1/3]

GeographicLib::LambertConformalConic::LambertConformalConic | ( | real | a,
|  | real | f,
|  | real | stdlat,
|  | real | k0 )

Constructor with a single standard parallel.

Parameters

  [in] | a | equatorial radius of ellipsoid (meters).
  [in] | f | flattening of ellipsoid. Setting f = 0 gives a sphere. Negative f gives a prolate ellipsoid.
  [in] | stdlat | standard parallel (degrees), the circle of tangency.
  [in] | k0 | scale on the standard parallel.

Exceptions

  GeographicErr | if a, (1 − f) a, or k0 is not positive.
  GeographicErr | if stdlat is not in [−90°, 90°].

Definition at line 16 of file LambertConformalConic.cpp.

References GeographicLib::Math::qd, and GeographicLib::Math::sincosd().

Referenced by Mercator().

## ◆ LambertConformalConic() [2/3]

GeographicLib::LambertConformalConic::LambertConformalConic | ( | real | a,
|  | real | f,
|  | real | stdlat1,
|  | real | stdlat2,
|  | real | k1 )

Constructor with two standard parallels.

Parameters

  [in] | a | equatorial radius of ellipsoid (meters).
  [in] | f | flattening of ellipsoid. Setting f = 0 gives a sphere. Negative f gives a prolate ellipsoid.
  [in] | stdlat1 | first standard parallel (degrees).
  [in] | stdlat2 | second standard parallel (degrees).
  [in] | k1 | scale on the standard parallels.

Exceptions

  GeographicErr | if a, (1 − f) a, or k1 is not positive.
  GeographicErr | if stdlat1 or stdlat2 is not in [−90°, 90°], or if either stdlat1 or stdlat2 is a pole and stdlat1 is not equal stdlat2.

Definition at line 41 of file LambertConformalConic.cpp.

References GeographicLib::Math::qd, and GeographicLib::Math::sincosd().

## ◆ LambertConformalConic() [3/3]

GeographicLib::LambertConformalConic::LambertConformalConic | ( | real | a,
|  | real | f,
|  | real | sinlat1,
|  | real | coslat1,
|  | real | sinlat2,
|  | real | coslat2,
|  | real | k1 )

Constructor with two standard parallels specified by sines and cosines.

Parameters

  [in] | a | equatorial radius of ellipsoid (meters).
  [in] | f | flattening of ellipsoid. Setting f = 0 gives a sphere. Negative f gives a prolate ellipsoid.
  [in] | sinlat1 | sine of first standard parallel.
  [in] | coslat1 | cosine of first standard parallel.
  [in] | sinlat2 | sine of second standard parallel.
  [in] | coslat2 | cosine of second standard parallel.
  [in] | k1 | scale on the standard parallels.

Exceptions

  GeographicErr | if a, (1 − f) a, or k1 is not positive.
  GeographicErr | if stdlat1 or stdlat2 is not in [−90°, 90°], or if either stdlat1 or stdlat2 is a pole and stdlat1 is not equal stdlat2.

This allows parallels close to the poles to be specified accurately. This routine computes the latitude of origin and the scale at this latitude. In the case where lat1 and lat2 are different, the errors in this routines are as follows: if dlat = abs(lat2 − lat1) ≤ 160° and max(abs(lat1), abs(lat2)) ≤ 90 − min(0.0002, 2.2 × 10−6(180 − dlat), 6 &times 10−8 dlat2) (in degrees), then the error in the latitude of origin is less than 4.5 × 10−14d and the relative error in the scale is less than 7 × 10−15.

Definition at line 73 of file LambertConformalConic.cpp.

References GeographicLib::Math::qd.

## Member Function Documentation

## ◆ SetScale()

void GeographicLib::LambertConformalConic::SetScale | ( | real | lat,
|  | real | k = real(1) )

Set the scale for the projection.

Parameters

  [in] | lat | (degrees).
  [in] | k | scale at latitude lat (default 1).

Exceptions

  GeographicErr | k is not positive.
  GeographicErr | if lat is not in [−90°, 90°].

Definition at line 450 of file LambertConformalConic.cpp.

References Forward(), and GeographicLib::Math::qd.

## ◆ Forward() [1/2]

void GeographicLib::LambertConformalConic::Forward | ( | real | lon0,
|  | real | lat,
|  | real | lon,
|  | real & | x,
|  | real & | y,
|  | real & | gamma,
|  | real & | k ) const

Forward projection, from geographic to Lambert conformal conic.

Parameters

  [in] | lon0 | central meridian longitude (degrees).
  [in] | lat | latitude of point (degrees).
  [in] | lon | longitude of point (degrees).
  [out] | x | easting of point (meters).
  [out] | y | northing of point (meters).
  [out] | gamma | meridian convergence at point (degrees).
  [out] | k | scale of projection at point.

The latitude origin is given by LambertConformalConic::LatitudeOrigin(). No false easting or northing is added and lat should be in the range [−90°, 90°]. The error in the projection is less than about 10 nm (10 nanometers), true distance, and the errors in the meridian convergence and scale are consistent with this. The values of x and y returned for points which project to infinity (i.e., one or both of the poles) will be large but finite.

Definition at line 340 of file LambertConformalConic.cpp.

References GeographicLib::Math::AngDiff(), GeographicLib::Math::degree(), GeographicLib::Math::eatanhe(), GeographicLib::Math::LatFix(), GeographicLib::Math::sincosd(), and GeographicLib::Math::sq().

Referenced by Forward(), main(), and SetScale().

## ◆ Reverse() [1/2]

void GeographicLib::LambertConformalConic::Reverse | ( | real | lon0,
|  | real | x,
|  | real | y,
|  | real & | lat,
|  | real & | lon,
|  | real & | gamma,
|  | real & | k ) const

Reverse projection, from Lambert conformal conic to geographic.

Parameters

  [in] | lon0 | central meridian longitude (degrees).
  [in] | x | easting of point (meters).
  [in] | y | northing of point (meters).
  [out] | lat | latitude of point (degrees).
  [out] | lon | longitude of point (degrees).
  [out] | gamma | meridian convergence at point (degrees).
  [out] | k | scale of projection at point.

The latitude origin is given by LambertConformalConic::LatitudeOrigin(). No false easting or northing is added. The value of lon returned is in the range [−180°, 180°]. The error in the projection is less than about 10 nm (10 nanometers), true distance, and the errors in the meridian convergence and scale are consistent with this.

Definition at line 382 of file LambertConformalConic.cpp.

References GeographicLib::Math::AngNormalize(), GeographicLib::Math::atand(), GeographicLib::Math::degree(), GeographicLib::Math::sq(), and GeographicLib::Math::tauf().

Referenced by main(), and Reverse().

## ◆ Forward() [2/2]

void GeographicLib::LambertConformalConic::Forward | ( | real | lon0,
|  | real | lat,
|  | real | lon,
|  | real & | x,
|  | real & | y ) const
| inline

LambertConformalConic::Forward without returning the convergence and scale.

Definition at line 267 of file LambertConformalConic.hpp.

References Forward().

## ◆ Reverse() [2/2]

void GeographicLib::LambertConformalConic::Reverse | ( | real | lon0,
|  | real | x,
|  | real | y,
|  | real & | lat,
|  | real & | lon ) const
| inline

LambertConformalConic::Reverse without returning the convergence and scale.

Definition at line 277 of file LambertConformalConic.hpp.

References Reverse().

## ◆ EquatorialRadius()

Math::real GeographicLib::LambertConformalConic::EquatorialRadius | ( |  | ) | const
| inline

Returns
  a the equatorial radius of the ellipsoid (meters). This is the value used in the constructor.

Definition at line 290 of file LambertConformalConic.hpp.

## ◆ Flattening()

Math::real GeographicLib::LambertConformalConic::Flattening | ( |  | ) | const
| inline

Returns
  f the flattening of the ellipsoid. This is the value used in the constructor.

Definition at line 296 of file LambertConformalConic.hpp.

## ◆ OriginLatitude()

Math::real GeographicLib::LambertConformalConic::OriginLatitude | ( |  | ) | const
| inline

Returns
  latitude of the origin for the projection (degrees).

This is the latitude of minimum scale and equals the stdlat in the 1-parallel constructor and lies between stdlat1 and stdlat2 in the 2-parallel constructors.

Definition at line 305 of file LambertConformalConic.hpp.

## ◆ CentralScale()

Math::real GeographicLib::LambertConformalConic::CentralScale | ( |  | ) | const
| inline

Returns
  central scale for the projection. This is the scale on the latitude of origin.

Definition at line 311 of file LambertConformalConic.hpp.

## ◆ Mercator()

const LambertConformalConic & GeographicLib::LambertConformalConic::Mercator | ( |  | ) |
| static

A global instantiation of LambertConformalConic with the WGS84 ellipsoid, stdlat = 0, and k0 = 1. This degenerates to the Mercator projection.

Definition at line 333 of file LambertConformalConic.cpp.

References LambertConformalConic(), GeographicLib::Constants::WGS84_a(), and GeographicLib::Constants::WGS84_f().

The documentation for this class was generated from the following files:

- LambertConformalConic.hpp
- LambertConformalConic.cpp